<!DOCTYPE html>
<!--
Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
Click nbfs://nbhost/SystemFileSystem/Templates/Other/html.html to edit this template
-->
<html xmlns:th="https://www.thymeleaf.org">
    <head>
        <title>TODO supply a title</title>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <script src="https://code.jquery.com/jquery-3.6.0.js" integrity="sha256-H+K7U5CnXl1h5ywQfKtSj8PCmoN9aaq30gDh27Xc0jk=" crossorigin="anonymous"></script>
        <script src="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.3.12/jstree.min.js" integrity="sha512-TGClBy3S4qrWJtzel4qMtXsmM0Y9cap6QwRm3zo1MpVjvIURa90YYz5weeh6nvDGKZf/x3hrl1zzHW/uygftKg==" crossorigin="anonymous" referrerpolicy="no-referrer"></script>
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/jstree/3.3.12/themes/default/style.min.css" integrity="sha512-pg7xGkuHzhrV2jAMJvQsTV30au1VGlnxVN4sgmG8Yv0dxGR71B21QeHGLMvYod4AaygAzz87swLEZURw7VND2A==" crossorigin="anonymous" referrerpolicy="no-referrer" />
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-0evHe/X+R7YkIZDRvuzKMRqM+OrBnVFBL6DOitfPri4tjfHxaWutUpFmBp4vmVor" crossorigin="anonymous">
        <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-pprn3073KE6tl6bjs2QrFaJGz5/SUsLqktiwsUTF55Jfv3qYSDhgCecCxMW52nD2" crossorigin="anonymous"></script>
    </head>
    <body>
        <div class="container">
            <div class="row">
                <div id="data" class="demo col-4"></div>
                <div class="col-8">
                    <div id="createFileMenu" style="display: none">
                        <input type="hidden" id="createFileMenu_FolderId" class="editComponent"/>
                        File Name: <input type="text" id="createFileMenu_FileName" class="editComponent form-control"/>
                        <div class="form-check">
                            <input type="radio" name="createFileMenu_Type" id="createFileMenu_Type_Folder" value="0" class="form-check-input"/>
                            <label class="form-check-label" for="createFileMenu_Type_Folder">
                                Folder
                            </label>
                        </div>
                        <div class="form-check">
                            <input type="radio" name="createFileMenu_Type" id="createFileMenu_Type_File" value="1" class="form-check-input"/>
                            <label class="form-check-label" for="createFileMenu_Type_File">
                                File
                            </label>
                        </div>
                        <button id="createFileMenu_ADD" class="btn btn-primary form-control">ADD</button><br/>
                        <button id="createFileMenu_DELETE" class="btn btn-danger form-control">DELETE</button>
                    </div>
                    <div id="editFileMenu" style="display: none">
                        <input type="hidden" id="editFileMenu_Id" class="editComponent"/><br/>
                        <input type="hidden" id="editFileMenu_contentId" class="editComponent"/><br/>
                        <textarea rows="15" id="editFileMenu_Content" class="editComponent form-control"></textarea><br/>
                        <button id="editFileMenu_EDIT"  class="btn btn-primary form-control">EDIT</button><br/>
                        <button id="editFileMenu_DELETE" class="btn btn-danger form-control">DELETE</button>
                    </div>
                </div>
                <script>
                    $("#createFileMenu_ADD").click(function () {
                        let fileItem = {
                            name: $("#createFileMenu_FileName").val(),
                            parentId: $("#createFileMenu_FolderId").val(),
                            file: $("input[name='createFileMenu_Type']:checked").val() === "1"
                        };
                        $.ajax("api/file", {
                            //Question 9(20%): 完成對 post 的呼叫，請務必在下列區域中作答
        
                            //Start of Question 9
        
                            //End of Question 9
                            success: function () {
                                window.location.reload();
                            }
                        });
                    });

                    $("#editFileMenu_EDIT").click(function () {
                        let fileItem = {
                            id: $("#editFileMenu_Id").val(),
                            content: {
                                content: $("#editFileMenu_Content").val()
                            }
                        };
                        if ($("#editFileMenu_contentId").val() && "" != $("#editFileMenu_contentId").val()) {
                            fileItem.content.id = $("#editFileMenu_contentId").val();
                        }
                        $.ajax("api/file", {
                            type: "PUT",
                            contentType: "application/json",
                            data: JSON.stringify(fileItem),
                            success: function () {
                                window.location.reload();
                            }
                        });
                    });

                    $("#editFileMenu_DELETE").click(function () {
                        $.ajax("api/file/id/" + $("#editFileMenu_Id").val(), {
                            type: "DELETE",
                            success: function () {
                                window.location.reload();
                            }
                        });
                    });

                    $("#createFileMenu_DELETE").click(function () {
                        $.ajax("api/file/id/" + $("#createFileMenu_FolderId").val(), {
                            type: "DELETE",
                            success: function () {
                                window.location.reload();
                            }
                        });
                    });

                    function fileItem2JsTreeEntry(item) {
                        let ret = {'text': item.node.name, id: item.id};
                        if (!item.file) {
                            ret.children = [];
                            for (let child of item.children) {
                                ret.children.push(fileItem2JsTreeEntry(child));
                                ret.state = {'opened': true};
                            }
                        } else {
                            ret.type = "file";
                            ret.icon = "images/paper.png";
                        }
                        return ret;
                    }

                    $.ajax("api/files", {
                        success: function (o) {
                            let rootMap = {};//map from root to child
                            for (let fileItem of o) {
                                if (fileItem.file == false) {
                                    rootMap[fileItem.id] = {id: fileItem.id, node: fileItem, children: [], file: false};
                                }
                            }
                            for (let fileItem of o) {
                                let parentId = fileItem.parentId;
                                if (parentId) {
                                    let parentEntry = rootMap[parentId];
                                    if (!rootMap[fileItem.id]) {
                                        parentEntry.children.push({
                                            id: fileItem.id, node: fileItem, children: [], file: fileItem.file
                                        });
                                    } else {
                                        parentEntry.children.push(rootMap[fileItem.id]);
                                    }
                                }
                            }
                            let tree = fileItem2JsTreeEntry(rootMap["-1"]);
                            $('#data').jstree({
                                'core': {
                                    'data': [
                                        tree
                                    ]
                                }
                            });
                        }
                    });



                    $('#data').on('activate_node.jstree', function (e, data) {
                        $("#editFileMenu").hide();
                        $("#createFileMenu").hide();
                        $(".editComponent").val("");
                        if (data == undefined || data.node == undefined || data.node.id == undefined)
                            return;
                        if (data.node.original.type != "file") {
                            $("#createFileMenu").show();
                            $("#createFileMenu_FolderId").val(data.node.original.id);
                        } else {
                            $("#editFileMenu").show();
                            $("#editFileMenu_Id").val(data.node.original.id);
                            $.ajax("api/file/id/" + data.node.original.id, {
                                success: function (o) {
                                    if (o.content) {
                                        $("#editFileMenu_contentId").val(o.content.id);
                                        $("#editFileMenu_Content").val(o.content.content);
                                    }
                                }
                            });
                        }
                    });
                </script>
            </div>
        </div>
    </body>
</html>
